<template>
    <div class="growth_new__actions actions">
        <div
            v-if="emailOffer.status"
            class="actions__item"
            :style="`order: ${emailOffer.order}`"
        >
            <div
                class="actions__type"
                :style="{backgroundColor:emailOffer.icon_background_color}"
            >
                <IconEmail :color="emailOffer.icon_color" />
            </div>

            <IconDone v-if="preview[orders.email].active" />

            <template v-else>
                <input
                    class="actions__input"
                    :placeholder="emailOffer.placeholder_text !== null ? emailOffer.placeholder_text : 'Your email address'"
                >
                <button
                    class="actions__btn"
                    :style="{backgroundColor: emailOffer.btn_color, color: emailOffer.btn_text_color}"
                >
                    Get Discount
                </button>
            </template>
        </div>
        <div
            v-if="smsOffer.status"
            class="actions__item"
            :style="`order: ${smsOffer.order}`"
        >
            <div
                class="actions__type"
                :style="{backgroundColor: smsOffer.icon_background_color}"
            >
                <IconSms :color="smsOffer.icon_color" />      
            </div>

            <IconDone v-if="preview[orders.sms].active" />

            <template v-else>
                <div class="carti-sms-input-container actions__input_sms">
                    <input
                        type="text"
                        value="+380"
                        class="carti-sms-country-code"
                    >
                    <input
                        required
                        type="number"  
                        :placeholder="smsOffer.placeholder_text !== null ? smsOffer.placeholder_text : 'Your phone number'"
                        class="carti-sms-input carti-form-control"
                    >
                </div>
                <button
                    class="actions__btn"
                    :style="{backgroundColor: smsOffer.btn_color, color: smsOffer.btn_text_color}"
                >
                    Get Discount
                </button>
            </template>
        </div>
        <div
            v-if="pushOffer.status"
            class="actions__item"
            :style="`order: ${pushOffer.order}`"
        >
            <div
                class="actions__type"
                :style="{backgroundColor:pushOffer.icon_background_color}"
            >
                <IconPush :color="pushOffer.icon_color" />
            </div>

            <IconDone v-if="preview[orders.push].active" />
      

            <template v-else>
                <div class="actions__input actions__input_push">
                    {{ pushOffer.placeholder_text !== null ? pushOffer.placeholder_text : 'Push notification' }}
                </div>
                <button
                    class="actions__btn"
                    :style="{backgroundColor: pushOffer.btn_color, color: pushOffer.btn_text_color}"
                >
                    Get Discount
                </button>
            </template>
        </div>
    </div>
</template>

<script>
  import IconDone from './icons/Done.vue'
  import IconPush from './icons/Push.vue'
  import IconSms from './icons/Sms.vue'
  import IconEmail from './icons/Email.vue'
  
  export default {
    components: {
      IconPush,
      IconSms,
      IconEmail,
      IconDone,
    },
    props: ['preview', 'popup'],
    computed: {
      position() {
          const position = []
          const defaultPos = ['email', 'sms', 'push']
          this.popup.growth_offers.forEach(el => {
              const optin = el.optin_channel 
              if(optin !== 'any') {
                  position.push(optin)
                  const index = defaultPos.indexOf(optin)
                  defaultPos.splice(index, 1)
              }
          })
          return position.concat(defaultPos)
      },

      emailOffer() {
        return this.popup.growth_offers[this.orders.email]
      },
      smsOffer() {
        return this.popup.growth_offers[this.orders.sms]
      },
      pushOffer() {
        return this.popup.growth_offers[this.orders.push]
      },
      orders() {
        return {
          email: this.position.indexOf('email'),
          sms: this.position.indexOf('sms'),
          push: this.position.indexOf('push'),
        }
      }
    }
  }
</script>
